#include <stdio.h>
#include <stdlib.h>
#include "signature.h"
#include "toptext.h"

void err(s) { fprintf(stderr,"%s\n",s); exit(0); }

main(int argc, char **argv)
{
  FILE *sigfile,*f;
  char *pat;
  char buf[5000+1];
  char patsig[SIGBYTES+1], textsig[SIGBYTES+1];
  char filename[1000];
  int n;

  if(argc < 3) err("% sigfind pat sigfile");

  pat = argv[1];
  if(strlen(pat) < 3)
    err("Pattern should be longer than 2 bytes");

  sigfile = fopen(argv[2],"r");
  if(sigfile == NULL)
    err("Cannot open signature file");

  calcsig(pat,patsig);

  while(fgets(buf,5000,sigfile)){
    sscanf(buf,"%s\t%s",filename,textsig);
    if(sigmatch(textsig,patsig)){
      if(f = fopen(filename,"r")){
        n = fread(buf,1,5000,f);
        buf[n] = '\0';
        if(strstr(toptext(buf),pat))
          printf("%s\n",filename);
        fclose(f);
      }
    }
  }
}



